behavior_name=yo
# yo16.ma
# Does 3 yos and restarts
# climb 5m   dive 20m alt 3m pitch 26 deg
# Hand Written
# 02-Jun-04 tc@DinkumSoftware.com From yo10.ma, 01-Jun-04
# 14-Dec-04 pfurey@DinkumSoftware.com Changed  dive_to args for deep electric
# 24-Dec-04 pfurey@DinkumSoftware.com Disable c/d_stop_when_hover/stalled_for 
#                                     arguments for the deep electric.
# 17-Jan-05 pfurey@DinkumSoftware.com Renamed to yo16.ma for de_line
# 24-Jun-05 pfurey@DinkumSoftware.com Changed target dive depth to 10m.

<start:b_arg>
    b_arg: start_when(enum)      2   # pitch idle (see doco below)
    b_arg: num_half_cycles_to_do(nodim) 6   # Number of dive/climbs to perform
                                     # <0 is infinite, i.e. never finishes

    # arguments for dive_to
    b_arg: d_target_depth(m)      10
    b_arg: d_target_altitude(m)   5

    b_arg: d_use_bpump(enum)      2
    b_arg: d_bpump_value(X)     -100.0
    b_arg: d_use_pitch(enum)      3
    b_arg: d_pitch_value(X)      -0.35 # inches
   
    b_arg: d_stop_when_hover_for(sec)   -1.0 # <0 disables
    b_arg: d_stop_when_stalled_for(sec) -1.0 # <0 diables

    # arguments for climb_to
    b_arg: c_target_depth(m)      5
    b_arg: c_target_altitude(m)  -1

    b_arg: c_use_bpump(enum)      2
    b_arg: c_bpump_value(X)      1000.0

    b_arg: c_use_pitch(enum)      3   # 1:battpos  2:setonce  3:servo
                                      #   in         rad        rad, >0 climb
    b_arg: c_pitch_value(X)     0.35     # in

    b_arg: c_stop_when_hover_for(sec)   -1.0 # <0 disables
    b_arg: c_stop_when_stalled_for(sec) -1.0 # <0 disables


    b_arg: end_action(enum) 2     # 0-quit, 2 resume
<end:b_arg>


# NOTE: These are symbolically defined beh_args.h
# b_arg: START_WHEN     When the behavior should start, i.e. go from UNITIALIZED to ACTIVE
#    BAW_IMMEDIATELY    0   // immediately
#    BAW_STK_IDLE       1   // When stack is idle (nothing is being commanded)
#    BAW_PITCH_IDLE     2   // When pitch is idle(nothing is being commanded)
#    BAW_HEADING_IDLE   3   // When heading is idle(nothing is being commanded)
#    BAW_UPDWN_IDLE     4   // When bpump/threng is idle(nothing is being commanded)
#    BAW_NEVER          5   // Never stop
#    BAW_WHEN_SECS      6   // After behavior arg "when_secs", from prior END if cycling
#    BAW_WHEN_WPT_DIST  7   // When sensor(m_dist_to_wpt) < behavior arg "when_wpt_dist"
#    BAW_WHEN_HIT_WAYPOINT 8 // When X_HIT_A_WAYPOINT is set by goto_wpt behavior
#    BAW_EVERY_SECS     9   // After behavior arg "when_secs", from prior START if cycling
#    BAW_EVERY_SECS_UPDWN_IDLE 10  // After behavior arg "when_secs", from prior START AND
#                                  //       updown is idle, no one commanding vertical motion
#    BAW_SCI_SURFACE    11  // SCI_WANTS_SURFACE is non-zero
#    BAW_NOCOMM_SECS    12  // when have not had comms for WHEN_SECS secs
#
# b_arg: STOP_WHEN
#   0   complete
#   1-N same as "start_when"
